transformers-0.3.0.0: Concrete functor and monad transformers

Copyright | (c) Ross Paterson 2010
License | BSD-style (see the file LICENSE)
Maintainer | ross@soi.city.ac.uk
Stability | experimental
Portability | portable
Safe Haskell | Safe-Inferred
Language | Haskell98

Data.Functor.Compose

Description

Composition of functors.

Synopsis

- newtype Compose f g a = Compose {
  - getCompose :: f (g a)
  }

# Documentation

newtype Compose f g a

Right-to-left composition of functors. The composition of applicative functors is always applicative, but the composition of monads is not always a monad.

Constructors

Compose |

Fields

getCompose :: f (g a)

Instances

(Alternative f, Applicative g) => Alternative (Compose f g) |
(Functor f, Functor g) => Functor (Compose f g) |
(Applicative f, Applicative g) => Applicative (Compose f g) |
(Foldable f, Foldable g) => Foldable (Compose f g) |
(Traversable f, Traversable g) => Traversable (Compose f g) |